// File: pppd.cc
//
// Time-stamp: <27-Oct-2002 13:20:46 goetz>
// $Id: $
//
// Copyright (C) 2002 by Novel Science International
//
// Author: me
//
// Description: 
// 
//

# include <stdio.h>
# include <stdlib.h>
# include <string.h>
# include <math.h>
# include <unistd.h>
# include <signal.h>
#include <sys/types.h>
#include <sys/resource.h>
#include <sys/wait.h>
#include "agendaSync.h"

// Note
// /etc/ppp/peers/agenda2Minkowsky must be installed rw-rw-rw- root root agenda2Minkowsky


int init_pppd(char *dev, int localIP, int remoteIP);
int start_pppd (pppdConnect *pdc);
int getPPPdevice(int pid);
unsigned int xtoi (char *t);
char *ip2str(char *t,unsigned int ip);
char *ip2sstr(char *t,unsigned int ip);
int getRemoteIP(pppdConnect *pdc);
void saveConnectionData(pppdConnect *pdc);

pppdConnect pdc;

#ifdef STANDALONE
int main ()
{
 
 pdc.pid =0;
 
 // start_pppd(&pdc);
  while(! start_pppd(&pdc))
   {
    printf("AS:\tuups try again\n");
    sleep(10);
   }
  while(true)
   ;
}
#endif

void term(int sig)
{
 printf("killing pppd %d\n",sig);
 close_pppd();
 exit(0);
}

void close_pppd()
{
 char file[1024];
 int ownpid = getpid();

 sprintf(file,"%s/.agendaSync",getenv("HOME"));
 printf("shutting pppd down %d %d (%d)\n",pdc.pid,pdc.ppid,ownpid);
 kill (pdc.pid,SIGTERM);
 if(ownpid != pdc.ppid)
  kill (pdc.ppid,SIGTERM);
 wait4(pdc.pid,NULL,0,NULL); 
 unlink(file);
}


int readConnectionData(pppdConnect *pdc)
{
 char file[1024],txt[256];
 FILE *fp;
 int pid;

 sprintf(file,"%s/.agendaSync",getenv("HOME"));
 fp = fopen (file,"r");
 if(fp == NULL)
  return false;

 fscanf(fp,"%d %d ppp%d %u %u %s\n",&pdc->pid,&pdc->ppid,&pdc->interface,
	&pdc->localIP,&pdc->remoteIP,pdc->serialDevice);
 fclose(fp);
 printf("PDC: pid =%d/%d  interface=ppp%d local-ip=%u/%s remote-ip=%u/%s dev=%s\n",pdc->pid,pdc->ppid,
	pdc->interface, pdc->localIP,ip2str(txt,pdc->localIP),pdc->remoteIP,ip2str(txt+64,pdc->remoteIP),
	pdc->serialDevice);
 return true;
}
void saveConnectionData(pppdConnect *pdc)
{
 char file[1024],txt[256];
 FILE *fp;

 sprintf(file,"%s/.agendaSync",getenv("HOME"));
 fp = fopen (file,"w");
 fprintf(fp,"%d %d ppp%1d %u %u %s  %s %s \n",pdc->pid,pdc->ppid,pdc->interface,
	 pdc->localIP,pdc->remoteIP,pdc->serialDevice,ip2str(txt,pdc->localIP),ip2str(txt+64,pdc->remoteIP));
 fclose(fp);
 printf("PDC: pid =%d/%d  interface=ppp%d local-ip=%u/%s remote-ip=%u/%s dev=%s\n",pdc->pid,pdc->ppid,
	pdc->interface, pdc->localIP,ip2str(txt,pdc->localIP),pdc->remoteIP,ip2str(txt+64,pdc->remoteIP),
	pdc->serialDevice);
}
int checkConnection(pppdConnect *pdc,char *tstFile, int *err)
{
 char file[1024],txt[256],cmd[1024],buf[256],t1[64],t2[64];
 char *str[64];
 FILE *fp;
 int ret;

 *err =0;
 sprintf(file,"/proc/%d/cmdline",pdc->pid);
 fp=fopen(file,"r");
 // printf("file='%s'=> %p\n",file,fp);
 if(fp == NULL)
  {
   *err=1;
   return false;
  }
 fgets(txt,255,fp);
 fclose(fp);

 str[0] = "pppd";
 str[1] = pdc->serialDevice;
 str[2] = "call";
 str[3] = "agenda2Minkowsky";
 sprintf(buf,"%s:%s",ip2str(t1,pdc->localIP),ip2str(t2,pdc->remoteIP));
 str[4] = buf;
 int p=0,l;
 for(int i=0;i<5; i++)
  {
   l =strlen(str[i]);
   if(strncmp(txt+p,str[i],l) != 0 )
    {
     *err = 10+i;
     return false;
    }
   p+= (l +1);
  }

 sprintf(cmd,"ping -c 2 -w 2 %s > /dev/null",ip2str(txt,pdc->remoteIP));
 ret = system(cmd);
 if(WEXITSTATUS(ret) != 0)
  {
   *err=10;
   return false;
  }


 sprintf(cmd,"rsync -n --timeout=2 default@%s::default/%s tst.dat > /dev/null",ip2str(txt,pdc->remoteIP),tstFile);
 ret = system(cmd);
 if(WEXITSTATUS(ret) != 0)
  {
   *err=11;
   return false;
  }

 return true;
}
int init_pppd(pppdConnect *pdc,char *dev, int localIP, int remoteIP)
{
 char t[64],t2[64];
 char file[1024];

 pdc->localIP= localIP;
 pdc->remoteIP= remoteIP;
 strcpy(pdc->serialDevice,dev);
 strcpy(pdc->peersFile,"agenda2Minkowsky");
 return(true);
}

int start_pppd (pppdConnect *pdc)
{
 char txt[256],t[64],t2[64];
 int success;
 char file [1024];
 FILE *fp;

 pdc->ppid =getpid();
 // printf("AS:\tfork pid is %d (my pid=%d)\n",pdc->pid,getpid());
 pdc->pid = fork();
 
 if( pdc->pid < 0)
   {
    printf("AS: \tCan't fork %d (my pid=%d)\n",pdc->pid,getpid());
    return false;
   }
  
 if( pdc->pid == 0)
  {
   printf("starting pppd pid=%d <- %d with %s  dev=%s\n",pdc->pid,getpid(),pdc->peersFile,pdc->serialDevice);
   close(1);
   close(2);
   sprintf(txt,"%s:%s",ip2str(t,pdc->localIP),ip2str(t2,pdc->remoteIP));
   execl("/usr/sbin/pppd", "pppd", pdc->serialDevice, "call", pdc->peersFile,txt, (void*)0);
  }
 signal(SIGTERM,term);
 signal(SIGINT,term);
 printf("pppd started: my pid=%d fork=%d %d\n",getpid(),pdc->pid);
 printf("Please start Network on Agenda VR3\n");
 saveConnectionData(pdc);


 int i=1;
 do
  {
   sleep(1);
   i++;
   success =pdc->interface= getPPPdevice(pdc->pid);
  }while (success <0);

 pdc->remoteIP=0xFFFFFFFFl;
 success=false;
 i=1;
 do
  {
   sleep(1);
   i++;
   success = getRemoteIP(pdc);
  }while (!success);
 printf("AS:\tconnected to %s on ppp%1d\n",ip2str(txt,pdc->remoteIP),pdc->interface);

 saveConnectionData(pdc);
 return true;
}

int getPPPdevice(int pid)
{
 FILE *fp;
 char file[256],buf[256];
 int i;

 for(i=0;i<10; i++)
  {
   sprintf(file,"/var/run/ppp%1d.pid",i);
   fp =fopen(file,"r");
   //   printf("AS:\t\tchecking %s : %p\n",file,fp);
   if(fp != NULL)
    {
     fgets(buf,255,fp);
     fclose(fp);
     //     printf("AS:\t\t\t %d (%s) = %d ?\n",atoi(buf),buf,pid);
     if(atoi(buf)==pid)
       return i;
    }
  }
 return -1;
}

int getRemoteIP(pppdConnect *pdc)
{
 char line[512],arg1[32],arg2[32],*t,is[16],id[16];
 FILE *fp;
 
 fp =fopen("/proc/net/route","r");
 if(fp == NULL)
  {
   printf("can't open /proc/net/route\n");
   return false;
  }

 sprintf(id,"ppp%1d",pdc->interface);
//  printf("AS:\t\tlooking for %s\n",id);
 while ( (t =fgets(line,511,fp)) != NULL)
  {
   sscanf(line,"%s %s",arg1,arg2);
//    printf("AS:\t\t\tchecking  %s %s for %s\n",arg1,arg2,id);
   if(strcmp(arg1,id)==0)
    {
     pdc->remoteIP = xtoi(arg2);
     return (true);
    }
  }
 return(false);
}

void rsyncIn (char *syncFile, char* poolFile)
{
 char cmd[1024],buf[64];

 sprintf(cmd,"rsync default@%s::default/%s %s",ip2str(buf,pdc.remoteIP),syncFile,poolFile);
 printf("get data with '%s'\n",cmd);
 system(cmd);
 printf("done\n\n");
}
void rsyncOut (char *syncFile, char* poolFile)
{
 char cmd[1024],buf[64];

 sprintf(cmd,"rsync  %s default@%s::default/%s",poolFile,ip2str(buf,pdc.remoteIP),syncFile);
 printf("put data with '%s'\n",cmd);
 system(cmd);
 printf("done\n\n");
}


unsigned int xtoi (char *t)
{
 unsigned int erg=0;
 int c=0;
 char *s=t;

 while(*s != '\0')
  {
//    printf("\t\t\t\txtoi char='%c'   int =%8X\n",*s,erg);
   if ( '0'<= *s && *s <= '9')
    erg =(erg <<4)+ (*s -'0');
   else if ( 'A'<= *s && *s <= 'F')
    erg =(erg <<4)+ (*s -'A' +10 );
   else if ( 'a'<= *s && *s <= 'f')
    erg =(erg <<4)+ (*s -'a' +10 );
   else
    return(erg);
   c++;
   s++;
//    printf("\t\t\t\txtoi         => int =%8X c=%1d\n",erg,c);
   if(c>=8)
    return(erg);
  }
 return(erg);
}

char *ip2sstr(char *t,unsigned int ip)
{
 sprintf(t,"%3d.%3d.%3d.%3d",
	 (ip & 0xFF000000) >> 24,
	 (ip & 0x00FF0000) >> 16,
	 (ip & 0x0000FF00) >>  8,
	 (ip & 0x000000FF) );
 return t;
}
char *ip2str(char *t,unsigned int ip)
{
 sprintf(t,"%d.%d.%d.%d",
	 (ip & 0xFF000000) >> 24,
	 (ip & 0x00FF0000) >> 16,
	 (ip & 0x0000FF00) >>  8,
	 (ip & 0x000000FF) );
 return t;
}
